#include "stdlib.h"
#include "stdio.h"
#include "./ivec.h"

int signum (int x) {
  if (x > 0) {
    return 1;
  } else if (x < 0) {
    return -1;
  } else {
    return 0;
  }
}

void main_ivec_map (Ivec * iv)  {
  /* ************************************************** */
  for (size_t i=0; i<ivec_length (iv); i++) {
    printf ("%7d,", *ivec_at (iv, i));
  }
  printf ("\n");
  /* ************************************************** */
  // ivec_map (iv, &abs);
  /* ************************************************** */
  for (size_t i=0; i<ivec_length (iv); i++) {
    printf ("%7d,", *ivec_at (iv, i));
  }
  printf ("\n");
  /* ************************************************** */
  ivec_map (iv, signum);
  /* ************************************************** */
  for (size_t i=0; i<ivec_length (iv); i++) {
    printf ("%7d,", *ivec_at (iv, i));
  }
  printf ("\n");
  /* ************************************************** */
}

void do_abs (int *ip) {
  *ip = abs (*ip);
}
void print_me (int *ip) {
  printf ("%7d,", *ip);
}

/* optional */
typedef enum Command {
  CMD_ABS,
  CMD_PRINT
} Command;

typedef void (*int_to_void) (int*);

int_to_void
choose (Command cmd) {
  switch (cmd) {
  case CMD_ABS:
    return &do_abs;
  case CMD_PRINT:
    return &print_me;
  }
}
/* optional end */

void printi (int i, int *ip) {
  printf ("%5d:%7d\n", i, *ip);
}

int main (int argc, char *argv[]) {
  Ivec *iv = ivec_new();
  for (size_t i=1; i<argc; i++) {
    ivec_push (iv, atoi (argv[i]));
  }
  /* ************************************************** */
  ivec_iter (iv, &print_me); // alternativ: ivec_iter(iv, choose (CMD_PRINT));
  printf ("\n");
  /* ************************************************** */
  ivec_iter (iv, &do_abs);
  /* ************************************************** */
  ivec_iter (iv, print_me);
  printf ("\n");
  /* ************************************************** */
  ivec_iteri (iv, printi);
  /* ************************************************** */
  return 0;
}
