#include "stdio.h"
#include "stdbool.h"
#include "reader.h"
#include "json_reader.h"
#include "json_data.h"

void read_from_stdin(void) {
    printf ("Reading from stdin ... \n");
    const char * contents = readfile ("-");
    reader *input = make_reader (contents);
    JsonValue *json = parse_json (input);
    printf ("\t%s\n", json ? "succeeds" : "fails");
    switch (json_value_type (json)) {
    case JSON_ARRAY:
      {
	Vec* ar = json_value_as_array (json);
	vec_iter (ar, (void (*)(void **))&json_value_increment);
      }
      break;
    default:
      break;
    }
    json_value_print (json);
    free (input);
    free ((void *) contents);
}

int main (int argc, char *argv[]) {
  if (argc > 1) {
    printf ("Parsing file %s ...\n", argv[1]);
    const char * contents = readfile (argv[1]);
    reader *input = make_reader (contents);
    JsonValue *json = parse_json (input);
    printf ("\t%s\n", json ? "succeeds" : "fails");
    if (json) {
      json_value_print (json);
    }
    free (input);
    free ((void *) contents);
  } else {
    // printf ("Usage: %s FILE ...\n", argv[0]);
    read_from_stdin();
  }
  exit (0);
}
